#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=PWScli.ico
#AutoIt3Wrapper_outfile=PWScli.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=N
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=PWScli
#AutoIt3Wrapper_Res_Description=PlugWise Stretch 2.0 commandline interface
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=2013 Phoenix Interactive
#AutoIt3Wrapper_Res_Field=PWScli v1.1 (2013-05-04) X86 Win32|Sebastiaan Ebeltjes
#AutoIt3Wrapper_Change2CUI=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;PlugWise Stretch 2.0 commandline interface gemaakt door:  Sebastiaan Ebeltjes (Phoenix Interactive)

#include <array.au3>
#include <String.au3>

;Variabelen definieren
Global $StretchIP, $StretchID, $ApplianceID, $SwitchStatus, $PostResponse, $PostStatus, $GetResponse, $GetStatus
ConsoleWrite("PWScli v1.1 (2013-05-04) X86 Win32 by Sebastiaan Ebeltjes" & @CRLF & @CRLF)

If $CmdLine[0] >= 4 Then ;Er zijn 4 of meer commando's opgegeven, we gaan aan de slag!
	$StretchIP = $CmdLine[1]
	$StretchID = $CmdLine[2]
	$ApplianceID = $CmdLine[3]
	$SwitchStatus = $CmdLine[4]

	;Controle & checks
	If StringIsDigit(StringReplace($StretchIP, ".", "")) = False Then Melding("The StretchIP can only contain numbers!")
	If StringLen(StringReplace($StretchIP, ".", "")) > 12 Then Melding("The given StretchIP is invalid, expected max 12 numbers!")
	If StringIsAlpha($StretchID) = False Then Melding("The StretchID can only contain letters!")
	If StringLen($StretchID) <> 8 Then Melding("The StretchID is invalid, expected 8 letters!")
	If StringLen($ApplianceID) <> 32 Then Melding("The ApplianceID is invalid, expected 32 characters!")
	If $SwitchStatus <> "on" And $SwitchStatus <> "off" Then Melding("The switch command can only be 'on' or 'off'!")

	ConsoleWrite("Stretch @ " & $StretchIP & @CRLF)
	ConsoleWrite("Switching ApplianceID: " & StringUpper($ApplianceID) & " to status: " & StringUpper($SwitchStatus) & @CRLF & "busy...")
	Schakelen($StretchIP, $StretchID, $ApplianceID, $SwitchStatus)

	If $PostStatus <> "200" Then
		ConsoleWrite("an error occured!, Stretch response:" & @CRLF & $PostResponse)
		Exit
	Else
		ConsoleWrite("switched!" & @CRLF)
	EndIf
	Exit
EndIf

If $CmdLine[0] >= 3 And $CmdLine[3] = "applist" Then
	$StretchIP = $CmdLine[1]
	$StretchID = $CmdLine[2]

	ConsoleWrite("Stretch @ " & $StretchIP & @CRLF)
	ConsoleWrite("retrieving appliances list...")

	GetData($StretchIP, $StretchID)

	If $Getstatus <> "200" Then
		ConsoleWrite("an error occured!, Stretch response:" & @CRLF & $GetResponse)
		Exit
	Else
		ConsoleWrite("ok...reading values..." & @CRLF & @CRLF)

		$GivenName = _StringBetween($GetResponse, "<name>", "</name>")
		$ApplianceID = _StringBetween($GetResponse, "<appliance id=" & Chr(34), Chr(34) & ">")
		Consolewrite("Name:" & @TAB & @TAB & "ApplianceID:" & @CRLF & @CRLF)
		For $loop = 1 to Ubound($GivenName) -1
			If StringLen($GivenName[$loop]) <= 6 Then Consolewrite($GivenName[$loop] & @TAB & @TAB & $ApplianceID[$loop] & @CRLF)
			If StringLen($GivenName[$loop]) > 6 Then Consolewrite($GivenName[$loop] & @TAB & $ApplianceID[$loop] & @CRLF)
		Next
	EndIf
	Exit
EndIf

ConsoleWrite("There are none or not enough commands given!" & @CRLF & @CRLF & "This is the usage of this program: " & @CRLF)
ConsoleWrite(@ScriptName & " [stretchIP] [stretchID] [ApplianceID] [on/off]" & @CRLF & @CRLF & @CRLF)
ConsoleWrite("To give a list of the appliance ID's: " & @CRLF & @ScriptName & " [stretchIP] [stretchID] applist" & @CRLF)
Exit


Func Schakelen($StretchIP, $StretchID, $ApplianceID, $SwitchStatus)
Global $PostAdres = "http://" & $StretchIP & "/minirest/appliances;id=" & $ApplianceID & "/power_state=" & $SwitchStatus
$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
$oHTTP.Open("POST", $PostAdres, False)
$oHTTP.SetRequestHeader("Host", $StretchIP)
$oHTTP.SetRequestHeader("Authorization", "Basic " & _Base64Encode("stretch:" & $StretchID))
$oHTTP.Send()
$PostResponse = $oHTTP.ResponseText
$PostStatus = $oHTTP.Status
EndFunc ;Schakelen


Func GetData($StretchIP, $StretchID)
Global $GetAdres = "http://" & $StretchIP & "/minirest/appliances"
$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
$oHTTP.Open("GET", $GetAdres, False)
$oHTTP.SetRequestHeader("Host", $StretchIP)
$oHTTP.SetRequestHeader("Authorization", "Basic " & _Base64Encode("stretch:" & $StretchID))
$oHTTP.Send()
$GetResponse = $oHTTP.ResponseText
$GetStatus = $oHTTP.Status
EndFunc ;Schakelen


Func _Base64Encode($sData)
    Local $oXml = ObjCreate("Msxml2.DOMDocument")
    If Not IsObj($oXml) Then
        SetError(1, 1, 0)
    EndIf

    Local $oElement = $oXml.createElement("b64")
    If Not IsObj($oElement) Then
        SetError(2, 2, 0)
    EndIf

    $oElement.dataType = "bin.base64"
    $oElement.nodeTypedValue = Binary($sData)
    Local $sReturn = $oElement.Text

    If StringLen($sReturn) = 0 Then
        SetError(3, 3, 0)
    EndIf

    Return $sReturn
EndFunc ;_Base64Encode

Func Melding($BerichtTekst)
ConsoleWrite($BerichtTekst & @CRLF)
Exit
EndFunc ;Melding